# My Application

The project is generated by [LoopBack](http://loopback.io).

# Install loopback

    npm install -g loopback

# Creating an application scafold

    slc loopback

# Creating models

    slc loopback:model

# Creating dataSource

    slc loopback:datasource

# Install MongoDB connector

    npm install loopback-connector-mongodb --save

# Connectiong model to dataSource

Open model-config.json and replace the following lines:

    "<MODEL NAME>": {
      "dataSource": "<DATA SOURCE NAME>",
      "public": true
    }

# Creating sample models

add the following code:

    module.exports = function(app) {
    // automigrate for models, everytime the app will running db will be replaced fot this data

		app.dataSources.motorcycleDataSource.automigrate('motorcycle', function(err) {
			if (err) throw err;

			app.models.Motorcycle.create(
				[
					{
						"make": "Harley Davidson",
						"model": "Knucklehead",
						"category": "Cruiser",
						"year": "1936",
						"id": "57337088fabe969f2dd4078e"
					},
					{
						"make": "Indian",
						"model": "Indian Chief",
						"category": "Cruiser",
						"year": "1938",
						"id": "573370a2fabe969f2dd4078f"
					},
					{
						"make": "Triumph",
						"model": "Speed Twin 500",
						"category": "Street",
						"year": "1938",
						"id": "573370bcfabe969f2dd40790"
					}

				], function(err, motorcycles) {
					if (err) throw err;
					console.log('Created Motorcycle Model: \n', motorcycles);
			});
		});

		app.dataSources.motorcycleDataSource.automigrate('review', function(err) {
			if (err) throw err;

			app.models.Review.create(
				[
					{
						"name": "Jax Teller",
						"email": "jax@teller.com",
						"id": "57337b82e630a9152ed6554d",
						"review": "I love the Knucklehead Motor",
						"ObjectId": "57337088fabe969f2dd4078e"
					},
					{
						"name": "Juice",
						"email": "juice@soa.com",
						"review": "Emblematic motorcycle of the world",
						"id": "5733845b00f4a48b2edd54cd",
						"ObjectId": "57337088fabe969f2dd4078e"
					}

				], function(err, reviews) {
					if (err) throw err;
					console.log('Created Review Model: \n', reviews);
			});
		});
	};


# Configuring server to server html content on client folder

1. create a index.html file inside client folder
2. comment or remove server/boot/root.js file
3. add the following code to middlewares.json

    "files": {
        "loopback#static": {
        "params": "$!../client"
      }
    },

# Ready to go
